<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <link href="https://brendan.ie/main.css" rel="stylesheet">

    <title>UL Room Finder</title>

    <meta content="UL Room Finder" name="title">
    <meta content="Brendan Golden" name="author">
    <meta content="Find free rooms in UL" name="description">

    <!-- for mobile devices -->
    <meta content="width=device-width,initial-scale=1" name="viewport">
    <!-- brendan.coffee -->
    <link href="https://brendan.ie/coffee/coffee.css" rel="stylesheet">
    <script src="https://brendan.ie/coffee/coffee.js"></script>
  </head>
  <body class="sticky-wrapper">
    <div id="coffee_anchor"><span id="served"></span></div>
    <script>C0FFEE()</script>

    <header>
      <h1>UL Room Finder</h1>
    </header>
    <main id="anchor">
      <p>
        Just a list of rooms that are free, and for how long.
        <br/>
        Note since it uses the timetable it cannot account for booked rooms, special events or lecturers using a free room. (basically non timetabled events)
        <br />
        <button onClick="run()" type="button">
          Refresh.
        </button>
      </p>
    </main>
    <footer>
      <span>
        <a href="https://gitlab.com/c2842/misc/ul_timetable_ical" rel='noopener noreferrer' target='_blank'>
          API source
        </a> | <wbr/>
        <a href="https://gitlab.com/brendan.ie/v1/-/blob/main/src/timetable/rooms.html" rel='noopener noreferrer' target='_blank'>
          Page source
        </a>
      </span>
      <br/>
      <span>
        © 2021-<span id="year">2021</span> | <wbr/>
        Brendan Golden | <wbr/>
        Email: contact_me(at symbol)brendan.ie <a href="mailto:contact_website@brendan.ie"></a><a href="mailto:contact@brendan.ie"></a>  | <wbr/>
        Gitlab: <a href="https://gitlab.com/Brendan_Golden">Brendan_Golden</a> | <wbr/>
        Discord: Silver#5563 | <wbr/>
        Mastodon: <a rel="me" href="https://mastodon.brendan.ie/@silver">@silver</a>
      </span>
    </footer>
    <script>
      /* I am a lazy fucker */
      document.getElementById('year').textContent = new Date().getFullYear().toString()
    </script>
    <script>


      run()

      async function run () {
        let hour = new Date().getHours();

        await fetch(`https://api.brendan.ie/timetable/rooms?hour=${hour}`)
          // get the data
          .then((response) => {
            if (!response.ok) {
              console.error(`HTTP error! Status: ${response.status}`)
              return []
            }
            return response.json()
          })
          // process it
          .then((data) => table_generate("room_table", data))
          .catch((err) => console.log(err))
      }

      function table_generate (table_id, data) {
        // remove existing table (if exists)
        table_delete(table_id)
        // create a new table
        let table = table_create(table_id)
        table_create_head(table_id, table, data)
        table_create_body(table_id, table, data)
      }

      function table_delete (table_id) {
        let table = document.getElementById(table_id)
        if (!table) {return}
        table.remove()
      }

      function table_create (table_id) {
        const table = document.createElement('table')

        const div = document.createElement('div')
        div.id = table_id
        div.appendChild(table)
        div.appendChild(document.createElement('br'))

        const anchor = document.getElementById('anchor')
        anchor.appendChild(div)

        return table
      }

      // thanks to https://www.valentinog.com/blog/html-table/ for some help
      function table_create_head (table_id, table, data) {
        let week_number = 1;
        let day_number = 0;
        if (data.length > 0){
          week_number = data[0].week;
          day_number = data[0].day;
        }

        const headers = [
          'Room',
          'Start Hour',
          'End Hour',
          'Duration'
        ]

        let thead = table.createTHead()
        let row_top = thead.insertRow()

        let week = document.createElement('th')
        week.appendChild(document.createTextNode(`Week ${week_number}`))
        week.style = 'width: 100px'
        row_top.appendChild(week)

        let day = document.createElement('th')
        day.appendChild(document.createTextNode(week_number_to_text(day_number)))
        day.colSpan = headers.length - 1
        day.id = `${table_id}_last_update`
        row_top.appendChild(day)

        // add the second row
        let row = thead.insertRow()
        for (let key of headers) {
          let th = document.createElement('th')
          let text = document.createTextNode(key)
          th.appendChild(text)
          row.appendChild(th)
        }
      }

      function week_number_to_text (n){
        switch (n){
          case 0 : return "Monday";
          case 1 : return "Tuesday";
          case 2 : return "Wednesday";
          case 3 : return "Thursday";
          case 4 : return "Friday";
          default : return "Not weekday";
        }
      }


      // https://stackoverflow.com/a/17709143/11964934
      function sort_data(objA, objB) {
        // Sort first on start time
        if (objA.start > objB.start) {
          return 1;
        } else if (objA.start < objB.start) {
          return -1;
        } else {
          // if start times are teh same then sort on name
          if (objA.name > objB.name) {
            return 1;
          } else if (objA.name < objB.name) {
            return -1;
          } else {
            return 0;
          }
        }

      }

      function table_create_body (table_id, table, data_raw) {

        // only show the type of results for this table
        let data = data_raw.sort(sort_data);

        outer: for (let element of data) {
          let row = table.insertRow()

          const valid = [
            'room',
            'start',
            'end',
            'duration'
          ]

          for (let key of valid) {
            if (typeof element[key] === 'undefined') {continue outer}

            let inner_text = element[key]

            if (key === 'start' ||key === 'end'){
              inner_text = `${element[key]}:00`
            }

            if (key === 'duration'){
              inner_text = `${element[key]}h`
            }


            let text = document.createTextNode(inner_text)

            let cell = row.insertCell()
            cell.appendChild(text)
          }
        }
      }

    </script>
  </body>
</html>